Program Dec2Hex;
{ Program to calculate min.inc, mid.inc and max.inc files according the
  definition file BANDS.TXT.
}
Uses
  Crt;
Const
  Hex       : Array [0..15] Of Char=('0','1','2','3','4','5','6','7',
                                     '8','9','A','B','C','D','E','F');
  MaxLongInt  : Real=2147483647.0;
Var
  HexNum,Line        : String;
  I,J,K              : Byte;
  AddMF              : Boolean;
  Temp,MF,CLK        : Real;
  DecNum             : LongInt;
  Out,Config         : Text;
  F1,F               : Array [1..8*3] Of Real;
  Error              : Word;

{ ---------------------- D2H ----------------------- }

  Function D2H(DecN: LongInt): String;
  Var  HexN          : String;
  Begin
    HexN:='';
    Repeat
      HexN:=Hex[DecN MOD 16]+HexN;
      DecN:=DecN DIV 16;
    Until DecN<16;
    HexN:=Hex[DecN]+HexN;
    While Length(HexN)<8 Do HexN:='0'+HexN;
    D2H:=HexN;
  End;

{ ====================================================================== }

Begin
  Assign(Config,'bands.txt');Reset(Config);
  ClrScr;
  ReadLn(Config,Line);
  Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
  Line:=Copy(Line,1,Pos(' ',Line)-1);
  Val(Line,CLK,Error);

  ReadLn(Config,Line);
  Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
  Line:=Copy(Line,1,Pos(' ',Line)-1);
  Val(Line,MF,Error);
  I:=0;
  Repeat
    ReadLn(Config,Line);
    Case Line[1] Of
    '+' : AddMF:=True;
    '-' : AddMF:=False;
    Else If Line[1] In ['0'..'9'] Then
      Begin
        Inc(I);
        Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
        Val(Line,F1[I],Error);
        If AddMF Then F[I]:=F1[I]+MF
        Else  F[I]:=F1[I]-MF;
      End;
    End;
  Until Eof(Config);
  Close(Config);

  Assign(Out,'min.inc');Rewrite(Out);
  WriteLn(Out,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J         :=1+(I-1)*3;
      Temp      :=F[J]*65536*(65536/CLK);
      If (Temp>MaxLongInt) Then
        Begin
          WriteLn('On band ',F1[J]:6:3,' you must change + into - IF!!!');
          WriteLn('Or calculate values using Windows version of the program!');
          ReadLn;
          Halt;
        End;

      HexNum    :=D2H(Round(Temp));

      WriteLn(Out,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(Out,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(Out,'');
    End;
  Close(Out);

  Assign(Out,'mid.inc');Rewrite(Out);
  WriteLn(Out,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J:=2+(I-1)*3;
      HexNum:=D2H(Round(F[j]*65536*(65536/CLK)));
      WriteLn(Out,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(Out,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(Out,'');
    End;

  Close(Out);
  Assign(Out,'max.inc');Rewrite(Out);
  WriteLn(Out,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J:=3+(I-1)*3;
      HexNum:=D2H(Round(F[J]*65536*(65536/CLK)));
      WriteLn(Out,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(Out,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(Out,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(Out,'');
    End;
  Close(Out);
End.