program dec2hexw;
{$APPTYPE CONSOLE}
{ Program to calculate min.inc, mid.inc and max.inc files according the
  definition file BANDS.TXT.}
uses
  SysUtils;

Const
  Hex       : Array [0..15] Of Char=('0','1','2','3','4','5','6','7',
                                     '8','9','A','B','C','D','E','F');
Var
  HexNum,Line        : String;

  I,J,Error          : Integer;

  AddMF              : Boolean;

  Temp,MF,CLK        : Real;

  TempInt            : Cardinal;

  OutFile,Config     : Text;

  F1,F               : Array [1..8*3] Of Real;

{ ---------------------- D2H ----------------------- }

  Function D2H(DecN: Cardinal): String;
  Var  HexN          : String;
  Begin
    HexN:='';
    Repeat
      HexN:=Hex[DecN MOD 16]+HexN;
      DecN:=DecN DIV 16;
    Until DecN<16;
    HexN:=Hex[DecN]+HexN;
    While Length(HexN)<8 Do HexN:='0'+HexN;
    D2H:=HexN;
  End;

{ ====================================================================== }

Begin
  AssignFile(Config,'bands.txt');Reset(Config);

  ReadLn(Config,Line);
  Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
  Line:=Copy(Line,1,Pos(' ',Line)-1);
  Val(Line,CLK,Error);

  ReadLn(Config,Line);
  Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
  Line:=Copy(Line,1,Pos(' ',Line)-1);
  Val(Line,MF,Error);
  I:=0;
  Repeat
    ReadLn(Config,Line);
    Case Line[1] Of
    '+' : AddMF:=True;
    '-' : AddMF:=False;
    Else If Line[1] In ['0'..'9'] Then
      Begin
        Inc(I);
        Line:=Copy(Line,Pos('=',Line)+1,Length(Line)-Pos('=',Line));
        Val(Line,F1[I],Error);
        If AddMF Then F[I]:=F1[I]+MF
        Else  F[I]:=F1[I]-MF;
      End;
    End;
  Until Eof(Config);
  CloseFile(Config);

  AssignFile(OutFile,'min.inc');Rewrite(OutFile);
  WriteLn(OutFile,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J:=1+(I-1)*3;
      Temp:=F[J]*65536*(65536/CLK);
      TempInt:=Round(Temp);
      HexNum:=D2H(TempInt);
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(OutFile,'');
    End;
  CloseFile(OutFile);

  AssignFile(OutFile,'mid.inc');Rewrite(OutFile);
  WriteLn(OutFile,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J:=2+(I-1)*3;
      HexNum:=D2H(Round(F[j]*65536*(65536/CLK)));
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(OutFile,'');
    End;

  CloseFile(OutFile);
  AssignFile(OutFile,'max.inc');Rewrite(OutFile);
  WriteLn(OutFile,';                                    input    VFO');
  For I:=1 To 8 Do
    Begin
      J:=3+(I-1)*3;
      HexNum:=D2H(Round(F[J]*65536*(65536/CLK)));
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,7,2),'h     ;',F1[J]:10:3,' ',F[J]:10:3);
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,5,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,3,2),'h');
      WriteLn(OutFile,'            retlw    0',Copy(HexNum,1,2),'h');
      WriteLn(OutFile,'');
    End;
  CloseFile(OutFile);
End.
